"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppSchema = exports.App = void 0;
const mongoose_1 = require("@nestjs/mongoose");
const artifact_schema_1 = require("./artifact.schema");
const localized_app_data_schema_1 = require("./localized-app-data.schema");
const tag_schema_1 = require("./tag.schema");
const media_link_schema_1 = require("./media-link.schema");
const language_support_schema_1 = require("./language-support.schema");
const play_mode_1 = require("./play-mode");
let App = class App {
};
__decorate([
    (0, mongoose_1.Prop)({ required: false }),
    __metadata("design:type", String)
], App.prototype, "playFabId", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: false, type: [artifact_schema_1.ArtifactSchema], default: [] }),
    __metadata("design:type", Array)
], App.prototype, "artifacts", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: true, default: false, index: true }),
    __metadata("design:type", Boolean)
], App.prototype, "visible", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: false, type: [localized_app_data_schema_1.LocalizedAppDataSchema], default: [] }),
    __metadata("design:type", Array)
], App.prototype, "localizations", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: true, type: [tag_schema_1.TagSchema], default: [] }),
    __metadata("design:type", Array)
], App.prototype, "tags", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: false }),
    __metadata("design:type", Date)
], App.prototype, "releasedOn", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: false, type: [media_link_schema_1.MediaLinkSchema], default: [] }),
    __metadata("design:type", Array)
], App.prototype, "mediaLinks", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: false, type: [language_support_schema_1.LanguageSupportSchema], default: [] }),
    __metadata("design:type", Array)
], App.prototype, "languages", void 0);
__decorate([
    (0, mongoose_1.Prop)({
        required: true,
        type: [String],
        default: [play_mode_1.PlayMode.SinglePlayer],
        enum: [play_mode_1.PlayMode.None, play_mode_1.PlayMode.Coop, play_mode_1.PlayMode.SinglePlayer, play_mode_1.PlayMode.MultiPlayer]
    }),
    __metadata("design:type", Array)
], App.prototype, "modes", void 0);
App = __decorate([
    (0, mongoose_1.Schema)({ timestamps: true, id: true, collection: 'apps' })
], App);
exports.App = App;
exports.AppSchema = mongoose_1.SchemaFactory.createForClass(App);
//# sourceMappingURL=app.schema.js.map